﻿-- Author      : Nogarder
-- Create Date : 2010/7/1 16:34:28

local NPA_HealthBar={}
--config
local NPA_HealthBar_DefaultSetting={
		["HealthBar_UpdateInterval"]=0.03,

	
		["HealthBar_BarData"]={
			OffsetX=0,
			OffsetY=0,
			Height=10,
			Width=120,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="Interface\\TargetingFrame\\UI-StatusBar",
			TextureBlend="BLEND",
			RAngle=0,
			DeepCheck=1,
			Top=0,
			Bottom=1,
			Left=0,
			Right=1
			},
		["HealthBar_BorderData"]={
			OffsetX=0,
			OffsetY=0,
			Height=18,
			Width=126,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="Interface\\Tooltips\\UI-StatusBar-Border",
			TextureBlend="BLEND",
			Top=0,
			Bottom=1,
			Left=0,
			Right=1,
			RAngle=0,
			DeepCheck=1
			},
	
	
		["HealthBar_BackgroundData"]={
			OffsetX=0,
			OffsetY=0,
			Height=10,
			Width=120,
			Red=0,
			Green=0,
			Blue=0,
			Alpha=0.5,
			Texture="Interface\\TargetingFrame\\UI-StatusBar",
			TextureBlend="BLEND",
			RAngle=0,
			DeepCheck=1,
			Top=0,
			Bottom=1,
			Left=0,
			Right=1
			},

		["HealthBar_HighlightData"]={
			OffsetX=0,
			OffsetY=0,
			Height=28,
			Width=136,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="Interface\\Addons\\NPA\\texture\\glow",
			TextureBlend="ADD",
			RAngle=0,
			DeepCheck=1,
			Top=0,
			Bottom=1,
			Left=0,
			Right=1
			},
		["HealthBar_LowHealthData"]={
			OffsetX=0,
			OffsetY=0,
			Height=40,
			Width=140,
			Red=1,
			Green=0,
			Blue=0,
			Alpha=1,
			Texture="Interface\\Addons\\NPA\\texture\\glow",
			TextureBlend="ADD",
			RAngle=0,
			DeepCheck=1,
			Top=0,
			Bottom=1,
			Left=0,
			Right=1
			},


		["HealthBar_EliteData"]={
			OffsetX=-70,
			OffsetY=-3,
			Height=26,
			Width=65,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="Interface\\Tooltips\\EliteNameplateIcon",
			TextureBlend="BLEND",
			RAngle=0,
			DeepCheck=1,
			Top=0,
			Bottom=1,
			Left=1,
			Right=0
			},


		["HealthBar_BossData"]={
			OffsetX=50,
			OffsetY=0,
			Height=15,
			Width=15,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="Interface\\TargetingFrame\\UI-TargetingFrame-Skull",
			TextureBlend="BLEND",
			RAngle=0,
			DeepCheck=1,
			Top=0,
			Bottom=1,
			Left=0,
			Right=1
			},

		["HealthBar_TextData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=0,
			OffsetY=0,
			ShadowX=1,
			ShadowY=-1,
			Size=11,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1
			},
		["HealthBar_LevelTextData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=50,
			OffsetY=0,
			ShadowX=1,
			ShadowY=-1,
			Size=11,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1
			},	
		["HealthBar_OffsetX"]=0,
		["HealthBar_OffsetY"]=0,

		["HealthBar_HealthText"]=1,
		["HealthBar_HealthMax"]=0,
		["HealthBar_HealthPercent"]=1,
		["HealthBar_LevelText"]=1,
		
		["HealthBar_ColorByHealth"]=0,
		["HealthBar_ColorByClass"]=1,
		["HealthBar_ColorByFaction"]=1,

		["HealthBar_DefaultColor"]=0,
		
		["HealthBar_BreakDown"]=1,
		["HealthBar_Short"]=1,

		["HealthBar_HideTotem"]=1,

		["HealthBar_Elite"]=1,
		["HealthBar_LeftElite"]=1,
		["HealthBar_BossIcon"]=1,

		["HealthBar_PercentMarker"]=1,
		["HealthBar_ColorTextByClass"]=0,
		["HealthBar_ColorTextByHealth"]=0,

		["HealthBar_ColorByThreat"]=0,

		["HealthBar_AlwaysHide"]=1,
		["HealthBar_ShowLowHealth"]=0,
		["HealthBar_LowHealthPercent"]=25,
		["HealthBar_Tapped"]=0,

	}
local NPA_HealthBar_Config=NPA_HealthBar_DefaultSetting

function NPA_HealthBar:ResetConfig()
	NPA_Config["HealthBar"]=CopyTable(NPA_HealthBar_DefaultSetting)
end


-- get global functions
local pairs = pairs
local floor = floor
local table_insert = table.insert
local unpack=unpack


--main

local NPA_HealthBar_Frame={}


local function NPA_HealthBar_ShortNumber(value)
	local ret
	local short=floor(value/100000000)/10
	if(short>1)then
		return (short).."g"
	else
		short=floor(value/100000)/10
		if(short>1)then
			return (short).."m"
		else
			short=floor(value/100)/10
			if(short>1)then
				return (short).."k"
			else
				return value
			end
		end
	end
end

local function NPA_HealthBar_BreakNumber(value)
	local str=""
	
	local bre=floor(value/1000000000)
	if(bre>0)then
		value=value-bre*1000000000
		str=bre..","
	end
	bre=floor(value/1000000)
	if(bre>0)then
		value=value-bre*1000000
		str=str..bre..","
	end
	bre=floor(value/1000)
	if(bre>0)then
		value=value-bre*1000
		str=str..bre..","
	end
	str=str..value

	return str
end

local NPA_ManageBar=NPA_Core.ManageBar

local function NPA_HealthBar_UpdateValue(value,max,mainframe,onupdate)
	if(value==nil or max==nil or max==0)then
		value=1
		max=1
	end
	local percent=floor(value/max*1000)/1000

	local bar=mainframe.HealthBar

	if(onupdate and percent==bar.Percent)then
		return
	end
	bar.Percent=percent

	NPA_ManageBar(nil,bar)

	local str=nil

	if(NPA_HealthBar_Config["HealthBar_HealthText"]==1)then
		if(NPA_HealthBar_Config["HealthBar_Short"]==1)then
			value=NPA_HealthBar_ShortNumber(value)
		elseif(NPA_HealthBar_Config["HealthBar_BreakDown"]==1)then
			value=NPA_HealthBar_BreakNumber(value)
		end
		str=value

	end

	if(NPA_HealthBar_Config["HealthBar_HealthMax"]==1)then
		if(NPA_HealthBar_Config["HealthBar_Short"]==1)then
			max=NPA_HealthBar_ShortNumber(max)
		elseif(NPA_HealthBar_Config["HealthBar_BreakDown"]==1)then
			max=NPA_HealthBar_BreakNumber(max)
		end

		str=value
		if(str==nil)then
			str=max
		else
			str=str.."/"..max
		end
	end

	if(NPA_HealthBar_Config["HealthBar_HealthPercent"]==1)then
		if(str==nil)then
			str=floor(percent*100)
			if(NPA_HealthBar_Config["HealthBar_PercentMarker"]==1)then
				str=str.."%"
			end
		else
			if(NPA_HealthBar_Config["HealthBar_PercentMarker"]==1)then
				str=str.." ("..floor(percent*100).."%)"
			else
				str=str.." ("..floor(percent*100)..")"
			end
		end
	end


	--colored by health
	if(NPA_HealthBar_Config["HealthBar_ColorByHealth"]==1)then
		bar:SetVertexColor((1-percent)*bar.R,percent*bar.G,0,1)
	end
	local ht=mainframe.Text
	ht:SetText(str)
	if(NPA_HealthBar_Config["HealthBar_ColorTextByHealth"]==1)then
		ht:SetTextColor((1-percent)*ht.R,percent*ht.G,0,1)
	end

	--lowhealth warning
	if(NPA_HealthBar_Config["HealthBar_ShowLowHealth"]==1 and percent<=NPA_HealthBar_Config["HealthBar_LowHealthPercent"]/100)then
		mainframe.LowHealth:Show()
	else
		mainframe.LowHealth:Hide()
	end

end

local function NPA_HealthBar_OnValueChanged(frame)
	-- --healthbar
	local value=frame:GetValue()
	local _,max =frame:GetMinMaxValues()

	NPA_HealthBar_UpdateValue(value,max,frame.NPAHook)
end


local function NPA_HealthBar_ReplaceDefault(default,plate,hostile)
	if(NPA_HealthBar_Config["HealthBar_BossIcon"]==1 and default.BossIcon:IsShown())then
		plate.LevelText:Hide()
		plate.Boss:Show()
	else
		plate.Boss:Hide()

		if(NPA_HealthBar_Config["HealthBar_LevelText"]==1)then
			local leveltext=default.LevelText
			local lt=plate.LevelText
			lt:SetText(leveltext:GetText())
			local r,g,b=leveltext:GetTextColor()
			lt:SetTextColor(r*lt.R,g*lt.G,b*lt.B)
			lt:Show()
		else
			plate.LevelText:Hide()
		end
	end

	--highlight
	local highlight=default.Highlight
	if(highlight:IsShown())then
		plate.Highlight:Show()
	else
		plate.Highlight:Hide()
	end

	--elite
	if(NPA_HealthBar_Config["HealthBar_Elite"]==1 and default.StateIcon:IsShown())then
		plate.Elite:Show()
	else
		plate.Elite:Hide()
	end

		
end

local Threat12Color={}
local Threat0Color={}
local Threat3Color={}


local function NPA_HealthBar_OnUpdate(_,self,guid,unitdata,_,guids,frame,hostile,isplayer,default,recentUpdated,recentGuessed)
	local classicon=frame["ClassIcon"]
	if(classicon and classicon.IsTotem==1 and NPA_HealthBar_Config["HealthBar_HideTotem"]==1 and (NPA_HealthBar_Config["HealthBar_AlwaysHide"]==1 or (guid~=guids.Target and guid~=guids.Mouseover)))then
		self:Hide()
		return
	elseif(default)then
		NPA_HealthBar_ReplaceDefault(default,self,hostile)
		if(guid==guids.Target or guid==guids.Mouseover)then
			self.Highlight:Show()
		end
	elseif(unitdata)then
		if(guid==guids.Target or guid==guids.Mouseover)then
			self.Highlight:Show()
		else
			self.Highlight:Hide()
		end
		NPA_HealthBar_UpdateValue(unitdata.GuessedHealth,unitdata.HealthMax,self,1)
	
		if((NPA_HealthBar_Config["HealthBar_BossIcon"]==1 and unitdata.Classification=="worldboss") or unitdata.Level==-1)then
			self.LevelText:Hide()
			self.Boss:Show()
		else
			self.Boss:Hide()

			if(NPA_HealthBar_Config["HealthBar_LevelText"]==1)then
				local lt=self.LevelText
				lt:SetText(unitdata.Level)
				lt:SetTextColor(lt.R,lt.G,lt.B)
				lt:Show()
			else
				self.LevelText:Hide()
			end
		end

		if(NPA_HealthBar_Config["HealthBar_ColorByFaction"]==1)then
			local bg=self.Background
			if(hostile==1)then
				bg:SetVertexColor(bg.R,0,0)
			elseif(hostile==0)then
				bg:SetVertexColor(0,bg.G,0)
			else
				bg:SetVertexColor(bg.R,bg.G,0)
			end
		end

		--elite
		if(NPA_HealthBar_Config["HealthBar_Elite"]==1 and (unitdata.Classification=="elite" or unitdata.Classification=="worldboss"))then
			self.Elite:Show()
		else
			self.Elite:Hide()
		end
	else
		self:Hide()
		return
	end

	--healthtext
	if(NPA_HealthBar_Config["HealthBar_ColorHealthByClass"]==1 and isplayer)then
		local ht=self.Text
		local color=RAID_CLASS_COLORS[unitdata.ClassMark] or {r=1,b=1,g=1}
		ht:SetTextColor(color.r*ht.R,color.g*ht.G,color.b*ht.B)
	end

	--set color
	local hb=self.HealthBar
	if(NPA_HealthBar_Config["HealthBar_Tapped"]==1 and unitdata and unitdata.Tapped)then
		hb:SetVertexColor(0.5,0.5,0.5)
	elseif(NPA_HealthBar_Config["HealthBar_ColorByHealth"]==1)then
		if(not default)then
			local nTime=GetTime()
			if(unitdata and recentGuessed)then
				local percent=unitdata.LastGuessed/unitdata.HealthMax
				hb:SetVertexColor((1-percent)*hb.R,percent*hb.G,0)
			end
		end
	elseif(NPA_HealthBar_Config["HealthBar_DefaultColor"]==1 and default)then
		local r,g,b=default.HealthBar:GetStatusBarColor()
		hb:SetVertexColor(r*hb.R,g*hb.G,b*hb.B)
	elseif(NPA_HealthBar_Config["HealthBar_ColorByThreat"]==1 and UnitAffectingCombat("player"))then
		local threat
		if(recentUpdated)then
			threat=unitdata.ThreatStatus
		else
			local glow=self.DefaultGlow
			if(glow and glow:IsShown())then
				threat=3
			else
				threat=nil
			end
		end
		if(threat==1 or threat==2)then
			local color=Threat12Color
			hb:SetVertexColor(color.R,color.G,color.B,color.A)
		elseif(threat==3)then
			local color=Threat3Color
			hb:SetVertexColor(color.R,color.G,color.B,color.A)
		else
			local color=Threat0Color
			hb:SetVertexColor(color.R,color.G,color.B,color.A)
		end		
	elseif(NPA_HealthBar_Config["HealthBar_ColorByClass"]==1)then
		if(unitdata and (default or recentGuessed)) then
			if(unitdata.IsPlayer==1)then
				local color=RAID_CLASS_COLORS[unitdata.ClassMark] or {r=1,b=1,g=1}
				hb:SetVertexColor(color.r*hb.R,color.g*hb.G,color.b*hb.B)
			elseif(hostile==1)then
				hb:SetVertexColor(hb.R,0,0)
			elseif(hostile==0)then
				hb:SetVertexColor(0,hb.G,0)
			else
				hb:SetVertexColor(hb.R,hb.G,0)
			end
		elseif(default)then
			local r,g,b=default.HealthBar:GetStatusBarColor()
			hb:SetVertexColor(r*hb.R,g*hb.G,b*hb.B)
		else
			hb:SetVertexColor(hb.R,hb.G,hb.B)
		end
	end
	--background
	if(NPA_HealthBar_Config["HealthBar_ColorByFaction"]==1)then
		local bg=self.Background
		if(hostile==1)then
			bg:SetVertexColor(bg.R,0,0)
		elseif(hostile==2)then
			bg:SetVertexColor(bg.R,bg.G,0)
		else
			bg:SetVertexColor(0,bg.G,0)
		end
	end



	self:Show()
end


local function NPA_HealthBar_OnShow(frame)
	NPA_HealthBar_OnValueChanged(frame)
	frame:Hide()
end


local ManageTexture=NPA_Core.TextureManager2
local ManageFont=NPA_Core.FontManager


local function NPA_HealthBar_SetFrame(mainframe)

	mainframe:SetPoint("CENTER",mainframe:GetParent(),"CENTER",NPA_HealthBar_Config["HealthBar_OffsetX"],NPA_HealthBar_Config["HealthBar_OffsetY"])

	ManageTexture(nil,mainframe.HealthBar,NPA_HealthBar_Config["HealthBar_BarData"],"CENTER",mainframe,"CENTER",1)

	ManageTexture(nil,mainframe.Border,NPA_HealthBar_Config["HealthBar_BorderData"],"CENTER",mainframe,"CENTER")

	ManageTexture(nil,mainframe.Highlight,NPA_HealthBar_Config["HealthBar_HighlightData"],"CENTER",mainframe,"CENTER")
	ManageTexture(nil,mainframe.LowHealth,NPA_HealthBar_Config["HealthBar_LowHealthData"],"CENTER",mainframe,"CENTER")

	ManageTexture(nil,mainframe.Elite,NPA_HealthBar_Config["HealthBar_EliteData"],"CENTER",mainframe,"CENTER")
		
	ManageTexture(nil,mainframe.Boss,NPA_HealthBar_Config["HealthBar_BossData"],"CENTER",mainframe,"CENTER")
	ManageTexture(nil,mainframe.Background,NPA_HealthBar_Config["HealthBar_BackgroundData"],"CENTER",mainframe,"CENTER")
	
	ManageFont(nil,mainframe.Text,NPA_HealthBar_Config["HealthBar_TextData"],"CENTER",mainframe,"CENTER")
	ManageFont(nil,mainframe.LevelText,NPA_HealthBar_Config["HealthBar_LevelTextData"],"CENTER",mainframe,"CENTER")

	if(NPA_Config["Threat"] and NPA_Config["Threat"]["Threat_Glow2Data"] and NPA_Config["Threat"]["Threat_Glow3Data"] and NPA_Config["Threat"]["Threat_Glow1Data"])then
		Threat12Color={
			R=NPA_Config["Threat"]["Threat_Glow2Data"].Red,
			G=NPA_Config["Threat"]["Threat_Glow2Data"].Green,
			B=NPA_Config["Threat"]["Threat_Glow2Data"].Blue,
			A=NPA_Config["Threat"]["Threat_Glow2Data"].Alpha}
		Threat0Color={
			R=NPA_Config["Threat"]["Threat_Glow3Data"],
			G=NPA_Config["Threat"]["Threat_Glow3Data"].Green,
			B=NPA_Config["Threat"]["Threat_Glow3Data"].Blue,
			A=NPA_Config["Threat"]["Threat_Glow3Data"].Alpha}
		Threat3Color={
			R=NPA_Config["Threat"]["Threat_Glow1Data"].Red,
			G=NPA_Config["Threat"]["Threat_Glow1Data"].Green,
			B=NPA_Config["Threat"]["Threat_Glow1Data"].Blue,
			A=NPA_Config["Threat"]["Threat_Glow1Data"].Alpha}
	else
		Threat12Color={
			R=1,
			G=1,
			B=0,
			A=1}
		Threat0Color={
			R=0,
			G=1,
			B=0,
			A=1}
		Threat3Color={
			R=1,
			G=0,
			B=0,
			A=1}
	end

end

local function NPA_HealthBar_HookFrame(frame)
	local mainframe=CreateFrame("Frame","NPA_HealthBar_MainFrame",frame)
	mainframe:SetHeight(1)
	mainframe:SetWidth(1)
	mainframe:SetPoint("CENTER",frame,"CENTER",0,0)
	mainframe:SetFrameStrata("LOW")
	mainframe:Hide()

	--create frame
	--use default for now


	local bar=mainframe:CreateTexture("NPA_HealthBar_Bar","BORDER",nil)
	bar:Show()
	
	local background=mainframe:CreateTexture("NPA_HealthBar_Background","BACKGROUND",nil)
	
	local barhighlight=mainframe:CreateTexture("NPA_HealthBar_Highlight","ARTWORK",nil)
	barhighlight:Hide()
	
	local lowhealth=mainframe:CreateTexture("NPA_HealthBar_LowHealth","ARTWORK",nil)
	lowhealth:Hide()

	local overlay=mainframe:CreateTexture("NPA_HealthBar_HealthBarOverlay","ARTWORK",nil)
	overlay:Show()
	
	local healthtext=mainframe:CreateFontString("NPA_HealthBar_Text","OVERLAY",nil)
	healthtext:Show()
	
	local leveltext=mainframe:CreateFontString("NPA_HealthBar_LevelText","OVERLAY",nil)
	leveltext:Hide()


	local elite=mainframe:CreateTexture("NPA_HealthBar_Elite","OVERLAY",nil)
	elite:Hide()

	local boss=mainframe:CreateTexture("NPA_HealthBar_Boss","OVERLAY",nil)
	boss:Hide()
	
	mainframe.HealthBar=bar
	mainframe.Text=healthtext
	mainframe.LevelText=leveltext
	mainframe.Highlight=barhighlight
	mainframe.Border=overlay
	mainframe.Elite=elite
	mainframe.Boss=boss
	mainframe.Background=background
	mainframe.LowHealth=lowhealth

	NPA_HealthBar_SetFrame(mainframe)
	table_insert(NPA_HealthBar_Frame,mainframe)


	--disable default
	local default=frame.Default
	if(default)then
		default.SpellIcon:SetTexCoord(0,0,0,0)

		default.Overlay:SetWidth(0)
		default.Overlay:SetTexCoord(0,0,0,0)
		default.Overlay:SetTexture(nil)

		default.Highlight:SetTexture(nil)

		default.NameText:SetWidth(0.1)
		default.LevelText:SetWidth(0.1)

		default.BossIcon:SetTexture(nil)
		default.StateIcon:SetTexture(nil)

		default.HealthBar:SetWidth(0.1)

		mainframe.DefaultGlow = default.NativeGlow

		--hook scripts
		local bar=default.HealthBar
		bar.NPAHook=mainframe
		bar:HookScript("OnValueChanged",NPA_HealthBar_OnValueChanged)
		bar:HookScript("OnShow",NPA_HealthBar_OnShow)
		bar:Hide()
		NPA_HealthBar_OnValueChanged(bar)
	end

	--update
	
	frame["HealthBar"]=mainframe
	
end

function NPA_HealthBar:ApplyConfig()
	NPA_Core:CheckConfigEntry("HealthBar",NPA_HealthBar_DefaultSetting)

	NPA_HealthBar_Config=NPA_Config["HealthBar"]

	for _,mainframe in pairs(NPA_HealthBar_Frame) do
		NPA_HealthBar_SetFrame(mainframe)
		local parent=mainframe:GetParent().Parent
		if(parent.Default and parent.Default.HealthBar)then
			NPA_HealthBar_OnValueChanged(mainframe:GetParent().Parent.Default.HealthBar)
		end
	end

end


NPA_Core:AddHook("HealthBar",NPA_HealthBar_HookFrame)
NPA_Core:AddModule("HealthBar",NPA_HealthBar)
NPA_Core:HookUpdate("HealthBar",NPA_HealthBar_OnUpdate,1)