﻿-- Author      : Nogarder
-- Create Date : 2010/7/4 16:33:11
--global functions
local table_insert = table.insert
local pairs = pairs

local Localization={}
local locale=GetLocale()
local Tooltips={}
if(locale=="zhTW")then
	Localization={
		["PageName"]="核心",
		["UnitData_UpdateInterval"]="單位數據採集間隔(秒)",
		["Frame_UpdateInterval"]="框架更新間隔(秒)",
		["GlobalSize"]="全局縮放",
		["Aura"]="增減益",
		["AutoHide"]="自動隱藏",
		["CastWarning"]="施法警告",
		["ClassIcon"]="職業圖標",
		["ComboPoint"]="連擊點數",
		["CoolDown"]="技能冷卻",
		["CrowdControl"]="控場提示",
		["HealthBar"]="生命條",
		["ManaBar"]="法力條",
		["QuestMark"]="任務指示",
		["RaidIcon"]="團隊標記",
		["ScrollText"]="戰鬥文字",
		["Speed"]="移動速度",
		["Target"]="目標",
		["Threat"]="仇恨",
		["WildGuess"]="猜測匹配(更少的鼠標滑過,但是偶爾會不準確)",
		["PowerMatch"]="猜测匹配(高資源佔用)",
		["CleanUp"]="釋放內存間隔(秒)(0表示不釋放)",
		["CleanUpTimer"]="釋放此時間內沒有更新過的數據(秒)",
		["RangeCheck"]="距離檢測",
		["Tracker"]="追踪",
		["CounterSpell"]="法術反制",
		["Enabled"]="啟用數據收集",
		["idtip"]="在鼠標提示中顯示法術id",
		["ClassInfo"]="職業信息",
		["Modules"]="模塊",
		["NameText"]="名稱文本",
		["TargetCount"]="目標計數",
		["ShieldWatch"]="護盾監視",
		["OnlySelected"]="未選中的目標不顯示複雜模塊(提升性能)" ,
		["SychonizeAnimation"]="同步所有動畫",
		["exCombat"]="脫離戰鬥",
		["OffsetX"]="全局X偏移",
		["OffsetY"]="全局Y偏移",
		["RoleCheck"]="角色檢查",
		["SaveData"]="保存單位數據(需要重載UI生效)"
	}
	Tooltips={ 
		["Core"]="控制所有模塊的開關,更新間隔,和整體偏移定位",
		["UnitData_UpdateInterval"]="兩次數據收集之間的時間間隔", 
		["Frame_UpdateInterval"]="兩次框體更新之間的時間間隔", 
		["GlobalSize"]="全局縮放,1表示100%", 
		["PowerMatch"]="使用收集到的名稱和血量數據來對照pve中的怪物,開啟時可以在大部分時間都不需要鼠標滑過,但是可能會不精確(當兩個怪物擁有完全相同的血量和名稱時--這種情況很少),並且佔用一些CPU資源", 
		["CleanUp"]="兩次釋放之間的時間間隔,釋放會清除指定時間內沒有更新的單位數據", 
		["CleanUpTimer"]="釋放所使用的最小時間限制", 
		["Enabled"]="一些模塊需要數據收集才能工作,比如[增減益][速度][法力條][施法警告]等等,關閉數據收集會停止這些模塊,但是其它模塊仍然會正常工作", 
		["idtip"]="附加到默認工具提示功能,顯示所有法術的法術id", 
		["Modules"]="模塊開關", 
		["OnlySelected"]="自動關閉未選中目標的大部分模塊(像[增減益]和[冷卻])來節約CPU資源", 
		["SychonizeAnimation"]="使所有的動畫從同樣的起點開始播放,速度和幀數量不會受到影響", 
		["Offset"]="全局偏移",
	}
elseif(locale=="zhCN")then
	Localization={
		["PageName"]="核心",
		["UnitData_UpdateInterval"]="单位数据采集间隔(秒)",
		["Frame_UpdateInterval"]="框架更新间隔(秒)",
		["GlobalSize"]="全局缩放",
		["Aura"]="增减益",
		["AutoHide"]="自动隐藏",
		["CastWarning"]="施法警告",
		["ClassIcon"]="职业图标",
		["ComboPoint"]="连击点数",
		["CoolDown"]="技能冷却",
		["CrowdControl"]="控场提示",
		["HealthBar"]="生命条",
		["ManaBar"]="法力条",
		["QuestMark"]="任务指示",
		["RaidIcon"]="团队标记",
		["ScrollText"]="战斗文字",
		["Speed"]="移动速度",
		["Target"]="目标",
		["Threat"]="仇恨",
		["PowerMatch"]="猜测匹配(高资源占用)",
		["CleanUp"]="释放内存间隔(秒)(0表示不释放)",
		["CleanUpTimer"]="释放此时间内没有更新过的数据(秒)",
		["RangeCheck"]="距离检测",
		["Tracker"]="追踪",
		["CounterSpell"]="法术反制",
		["Enabled"]="启用数据收集",
		["idtip"]="在鼠标提示中显示法术id",
		["ClassInfo"]="职业信息",
		["Modules"]="模块",
		["NameText"]="名称文本",
		["TargetCount"]="目标计数",
		["ShieldWatch"]="护盾监视",
		["OnlySelected"]="未选定的目标不显示复杂模块(提升性能)" ,
		["SychonizeAnimation"]="同步所有动画",
		["exCombat"]="脱离战斗",
		["OffsetX"]="全局X偏移",
		["OffsetY"]="全局Y偏移",
		["RoleCheck"]="角色检查",
		["SaveData"]="保存单位数据(需要重载UI生效)"
	}
	Tooltips={
		["Core"]="控制所有模块的开关,更新间隔,和整体偏移定位",
		["UnitData_UpdateInterval"]="两次数据收集之间的时间间隔",
		["Frame_UpdateInterval"]="两次框体更新之间的时间间隔",
		["GlobalSize"]="全局缩放,1表示100%",
		["PowerMatch"]="使用收集到的名称和血量数据来对照pve中的怪物,开启时可以在大部分时间都不需要鼠标滑过,但是可能会不精确(当两个怪物拥有完全相同的血量和名称时--这种情况很少),并且占用一些CPU资源",
		["CleanUp"]="两次释放之间的时间间隔,释放会清除指定时间内没有更新的单位数据",
		["CleanUpTimer"]="释放所使用的最小时间限制",
		["Enabled"]="一些模块需要数据收集才能工作,比如[增减益][速度][法力条][施法警告]等等,关闭数据收集会停止这些模块,但是其它模块仍然会正常工作",
		["idtip"]="附加到默认工具提示功能,显示所有法术的法术id",
		["Modules"]="模块开关",
		["OnlySelected"]="自动关闭未选中目标的大部分模块(像[增减益]和[冷却])来节约CPU资源",
		["SychonizeAnimation"]="使所有的动画从同样的起点开始播放,速度和帧数量不会受到影响",
		["Offset"]="全局偏移",
	}
else
	Localization={
		["PageName"]="Core",
		["UnitData_UpdateInterval"]="Unit data update interval (Second)",
		["Frame_UpdateInterval"]="Frame update interval (Second)",
		["GlobalSize"]="Global size",
		["Aura"]="Aura",
		["AutoHide"]="AutoHide",
		["CastWarning"]="CastWarning",
		["ClassIcon"]="ClassIcon",
		["ComboPoint"]="ComboPoint",
		["CoolDown"]="CoolDown",
		["CrowdControl"]="CrowdControl",
		["HealthBar"]="HealthBar",
		["ManaBar"]="ManaBar",
		["QuestMark"]="QuestMark",
		["RaidIcon"]="RaidIcon",
		["ScrollText"]="ScrollText",
		["Speed"]="Speed",
		["Target"]="Target",
		["Threat"]="Threat",
		["PowerMatch"]="Guessing match (High CPU usage)",
		["CleanUp"]="Release memory every (Second)(0 means don't)",
		["CleanUpTimer"]="Release data not updated in (Second)",
		["RangeCheck"]="RangeCheck",
		["Tracker"]="Tracker",
		["CounterSpell"]="CounterSpell",
		["Enabled"]="Enable data collect",
		["idtip"]="Show spellid in tooltips",
		["ClassInfo"]="ClassInfo",
		["Modules"]="Modules",
		["NameText"]="NameText",
		["TargetCount"]="TargetCount",
		["ShieldWatch"]="ShieldWatch",
		["OnlySelected"]="Hide complex modules on non-selected (Increase performance)",
		["SychonizeAnimation"]="Sychonize all animation",
		["exCombat"]="exCombat",
		["OffsetX"]="Global offsetX",
		["OffsetY"]="Global offsetY",
		["RoleCheck"]="RoleCheck",
		["SaveData"]="Save unit data (Require ui reload)"
	}

	Tooltips={
		["Core"]="Controls on/off ,updating interval,and offsets of all modules",
		["UnitData_UpdateInterval"]="How much time between two data-collecting",
		["Frame_UpdateInterval"]="How much time between two updates of frame",
		["GlobalSize"]="Global size, 1 means 100%",
		["PowerMatch"]="Using collected name and health to match pve mob frame, turn it on can make mouseover unrequired most of the time, but maybe inaccurcy(if two mob have exactly same name and health -- which is rare) and cost some cpu power",
		["CleanUp"]="How much time between two clear, clear will delete unit data which are not updated within time limit",
		["CleanUpTimer"]="The time limit for releaseing memory",
		["Enabled"]="Some of modules depend on data collecting,like [Aura][Speed][ManaBar][CastWarning] etc., turn it off will disable those ,but other modules would still work",
		["idtip"]="Addition to default tooltip function to show a spellid for all spells",
		["Modules"]="Modules switches",
		["OnlySelected"]="Automaticly turn off most modules(like [Aura] and [Cooldown]) when not seleted to save cpu power",
		["SychonizeAnimation"]="Make all animated texture plays at the same start point, speed and frame count are not affected",
		["Offset"]="Global offset",
	}
end

local mainframe=NPA_Options:AddPage("NPA_Options_Core",Localization["PageName"],"Core",Tooltips["Core"])
local Options=mainframe.Options

local checkbox=NPA_Options:CreateCheckBox("NPA_Options_Core_idtip",mainframe,21,Localization["idtip"],"idtip",Tooltips["idtip"])
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",20,-20)
table_insert(Options,checkbox)

local checkbox=NPA_Options:CreateCheckBox("NPA_Options_Core_Enabled",mainframe,21,Localization["Enabled"],"Enabled",Tooltips["Enabled"])
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",20,-41)
table_insert(Options,checkbox)



local slideredit=NPA_Options:CreateSliderEdit("NPA_Options_Core_UnitData_UpdateInterval",mainframe,Localization["UnitData_UpdateInterval"],"UnitData_UpdateInterval",0.01,1,0.01,nil,nil,Tooltips["UnitData_UpdateInterval"])
slideredit:SetPoint("TOPLEFT",mainframe,"TOPLEFT",20,-62)
table_insert(Options,slideredit)

local slideredit=NPA_Options:CreateSliderEdit("NPA_Options_Core_Frame_UpdateInterval",mainframe,Localization["Frame_UpdateInterval"],"Frame_UpdateInterval",0.01,1,0.01,nil,nil,Tooltips["Frame_UpdateInterval"])
slideredit:SetPoint("TOPLEFT",mainframe,"TOPLEFT",20,-102)
table_insert(Options,slideredit)

local slideredit=NPA_Options:CreateSliderEdit("NPA_Options_Core_GlobalSize",mainframe,Localization["GlobalSize"],"GlobalSize",0.1,10,0.01,nil,nil,Tooltips["GlobalSize"])
slideredit:SetPoint("TOPLEFT",mainframe,"TOPLEFT",20,-162)
table_insert(Options,slideredit)

local checkbox=NPA_Options:CreateCheckBox("NPA_Options_Core_PowerMatch",mainframe,21,Localization["PowerMatch"],"PowerMatch",Tooltips["PowerMatch"])
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",20,-222)
table_insert(Options,checkbox)

local slideredit=NPA_Options:CreateSliderEdit("NPA_Options_Core_CleanUp",mainframe,Localization["CleanUp"],"CleanUp",0,3600,1,nil,nil,Tooltips["CleanUp"])
slideredit:SetPoint("TOPLEFT",mainframe,"TOPLEFT",20,-263)
table_insert(Options,slideredit)

local slideredit=NPA_Options:CreateSliderEdit("NPA_Options_Core_CleanUpTimer",mainframe,Localization["CleanUpTimer"],"CleanUpTimer",30,3600,1,nil,nil,Tooltips["CleanUpTimer"])
slideredit:SetPoint("TOPLEFT",mainframe,"TOPLEFT",20,-304)
table_insert(Options,slideredit)



local checkbox=NPA_Options:CreateCheckBox("NPA_Options_Core_OnlySelected",mainframe,21,Localization["OnlySelected"],"OnlySelected",Tooltips["OnlySelected"])
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",6,-386)
table_insert(Options,checkbox)

local checkbox=NPA_Options:CreateCheckBox("NPA_Options_Core_SychonizeAnimation",mainframe,21,Localization["SychonizeAnimation"],"SychonizeAnimation",Tooltips["SychonizeAnimation"])
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",6,-410)
table_insert(Options,checkbox)


local checkbox=NPA_Options:CreateCheckBox("NPA_Options_Core_SaveData",mainframe,21,Localization["SaveData"],"SaveData")
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",6,-434)
table_insert(Options,checkbox)


local sliderlist={
	["OffsetX"]={
		Name=Localization["OffsetX"],
		Min=-50,
		Max=50,
		Step=1,
		Width=140,
		OffsetX=20,
		OffsetY=-460
	},
	["OffsetY"]={
		Name=Localization["OffsetY"],
		Min=-50,
		Max=50,
		Step=1,
		Width=140,
		OffsetX=190,
		OffsetY=-460
	},
}

local tooltipslist={
	["OffsetX"]=Tooltips["Offset"],
	["OffsetY"]=Tooltips["Offset"],
}

NPA_Options:BuildSliderList("NPA_Options_Core",mainframe,sliderlist,Options,tooltipslist)
-----------filters
--------------------
local listframe=NPA_Options:CreateFrame("NPA_Options_Core_Modules",mainframe,Localization["Modules"],Tooltips["Modules"])
listframe:SetPoint("TOPRIGHT",-6,-5)
listframe:SetPoint("BOTTOMRIGHT",-6,6)
listframe:SetWidth(180)


local checkboxdata={
	["Aura"]=Localization["Aura"],
	["AutoHide"]=Localization["AutoHide"],
	["CastWarning"]=Localization["CastWarning"],
	["ClassIcon"]=Localization["ClassIcon"],
	["ComboPoint"]=Localization["ComboPoint"],
	["CoolDown"]=Localization["CoolDown"],
	["CrowdControl"]=Localization["CrowdControl"],
	["HealthBar"]=Localization["HealthBar"],
	["ManaBar"]=Localization["ManaBar"],
	["RaidIcon"]=Localization["RaidIcon"],
	["ScrollText"]=Localization["ScrollText"],
	["Speed"]=Localization["Speed"],
	["Target"]=Localization["Target"],
	["Threat"]=Localization["Threat"],
	["QuestMark"]=Localization["QuestMark"],
	["RangeCheck"]=Localization["RangeCheck"],
	["Tracker"]=Localization["Tracker"],
	["CounterSpell"]=Localization["CounterSpell"],
	["ClassInfo"]=Localization["ClassInfo"],
	["NameText"]=Localization["NameText"],
	["TargetCount"]=Localization["TargetCount"],
	["ShieldWatch"]=Localization["ShieldWatch"],
	["exCombat"]=Localization["exCombat"],
	["RoleCheck"]=Localization["RoleCheck"],

}


NPA_Options:BuildCheckBoxList("NPA_Options_Core",listframe,21,checkboxdata,21,Options,1)

mainframe:Show()